<template>
    <TableHeader area datePicker nextFlag theCurrentTime showTimeAll ref="TableHeaderRef" showExport showCustomColumn>
        <template v-slot:select>
            <el-form-item label="监督类型">
                <el-select v-model="tableStore.table.params.supvType" clearable placeholder="请选择监督类型" filterable>
                    <el-option
                        v-for="item in supvTypeOptionList"
                        :key="item.id"
                        :label="item.name"
                        :value="item.id"
                    ></el-option>
                </el-select>
            </el-form-item>
            <el-form-item label="流程状态">
                <el-select v-model="tableStore.table.params.status" clearable placeholder="请选择流程状态" filterable>
                    <el-option
                        v-for="item in statusSelect"
                        :key="item.id"
                        :label="item.name"
                        :value="item.id"
                    ></el-option>
                </el-select>
            </el-form-item>
        </template>
        <template #operation>
            <el-button icon="el-icon-Delete" type="primary" @click="deleteEven">删除</el-button>
        </template>
    </TableHeader>
    <Table ref="tableRef" :checkbox-config="checkboxConfig" />
    <!-- 新增 -->
    <planTest ref="planTestRef" @onsubmit="tableStore.index()" />
</template>
<script setup lang="ts">
import { ref, onMounted, provide, watch, nextTick } from 'vue'
import { useAdminInfo } from '@/stores/adminInfo'
//获取登陆用户姓名和部门
const adminInfo = useAdminInfo()
import TableStore from '@/utils/tableStore'
import Table from '@/components/table/index.vue'
import TableHeader from '@/components/table/header/index.vue'
import { ElMessage, ElMessageBox } from 'element-plus'
import { cancelTest } from '@/api/process-boot/generalTest'
import planTest from './planTest.vue'
import { useRouter } from 'vue-router'
import { deleteSurveyPlanTest } from '@/api/supervision-boot/delete/index'
import { queryPlan, removeSurvey } from '@/api/process-boot/generalTest'
import { getUserByRoleType } from '@/api/user-boot/user'

const { push } = useRouter()
const tableRef = ref()
import { useDictData } from '@/stores/dictData'

const dictData = useDictData()
const supvTypeOptionList = dictData.getBasicData('supv_type')
const statusSelect = dictData.statusSelect()

const planTestRef = ref()
const TableHeaderRef = ref()
const auditList: any = ref([])

const tableStore = new TableStore({
    url: '/supervision-boot/surveyTest/surveyTestPage',
    publicHeight: 65,
    method: 'POST',
    filename: '技术监督测试管理',
    column: [
        {
            width: '60',
            type: 'checkbox'
        },
        {
            title: '序号',
            width: 80,
            formatter: (row: any) => {
                return (tableStore.table.params.pageNum - 1) * tableStore.table.params.pageSize + row.rowIndex + 1
            }
        },
        { field: 'planName', title: '计划名称', minWidth: 140 },
        {
            field: 'supvType',
            title: '监督类型',
            minWidth: 130,
            formatter: (row: any) => {
                return supvTypeOptionList.filter(item => item.id === row.cellValue)[0]?.name
            }
        },
        {
            field: 'supvObjectName',
            minWidth: 130,
            title: '监督对象名称'
        },
        { field: 'substationName', title: '变电站', minWidth: 140 },
        { field: 'planStartTime', title: '计划开始时间', minWidth: 140 },
        { field: 'planEndTime', title: '计划结束时间', minWidth: 140 },
        {
            field: 'problemFlag',
            title: '是否存在问题',
            minWidth: 120,
            render: 'tag',
            custom: {
                0: 'success',
                1: 'danger',
                null: 'primary'
            },
            replaceValue: {
                0: '合格',
                1: '存在问题',
                null: '待测试'
            }
        },
        { field: 'deptName', title: '负责单位', minWidth: 140 },
        { field: 'completeBy', title: '计划负责人', minWidth: 130 },
        { field: 'completeTime', title: '实际完成时间', minWidth: 140 },
        {
            field: 'status',
            title: '流程状态',
            render: 'tag',
            minWidth: 140,
            custom: {
                0: 'warning',

                1: 'primary',
                2: 'success',
                3: 'danger',
                4: 'warning'
            },
            replaceValue: {
                0: '待提交审批',

                1: '审批中',
                2: '审批通过',
                3: '审批不通过',
                4: '已取消'
            }
        },
        {
            field: 'createBy',
            title: '填报人',
            minWidth: 120,
            formatter: (row: any) => {
                return dictData.state.userList.filter(item => item.id == row.cellValue)[0]?.name
            }
        },
        {
             title: '操作',fixed: 'right',
            minWidth: 180,
            render: 'buttons',
           
            buttons: [
                {
                    name: 'productSetting',
                    title: '测试填报',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    disabled: row => {
                        return row.status != 6
                    },
                    click: row => {
                        add(row.id)
                    }
                },
                {
                    name: 'productSetting',
                    title: '流程详情',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    disabled: row => {
                        return row.status == 6 || !row.processInstanceId
                    },
                    click: row => {
                        // planTestRef.value.open('查看计划', row)
                        handleAudit(row.processInstanceId, row.historyInstanceId)
                    }
                },
                {
                    name: 'edit',
                    title: '编辑',
                    type: 'primary',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    showDisabled: row => {
                        return row.deptId != adminInfo.$state.deptId || !(row.status == 0)
                    },
                    disabled: row => {
                        return !(row.status == 0)
                    },
                    click: row => {
                        planTestRef.value.open('编辑', row.id, false)
                    }
                },
                {
                    name: 'edit',
                    title: '重新发起',
                    type: 'warning',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    disabled: row => {
                        return row.deptId != adminInfo.$state.deptId || !(row.status == 3 || row.status == 4)
                    },
                    click: row => {
                        planTestRef.value.open('重新发起计划测试', row.id, false)
                    }
                },
                {
                    name: 'cancel',
                    title: '取消',
                    type: 'danger',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    disabled: row => {
                        return row.deptId != adminInfo.$state.deptId || row.status != 1
                    },
                    click: row => {
                        cancelLeave(row)
                    }
                }
            ]
        }
    ],
    beforeSearchFun: () => {
        tableStore.table.params.orgNo = tableStore.table.params.deptIndex
        tableStore.table.params.currentPage = tableStore.table.params.pageNum
    },
    exportProcessingData: () => {
        tableStore.table.allData = tableStore.table.allData.filter(item => {
            item.problemFlag = item.problemFlag == 0 ? '合格' : item.problemFlag == 1 ? '存在问题' : '待测试'
            item.status =
                item.status == 0
                    ? '待提交审批'
                    : item.status == 1
                    ? '审批中'
                    : item.status == 2
                    ? '审批通过'
                    : item.status == 3
                    ? '审批不通过'
                    : '已取消'
            return item
        })
    }
})

tableStore.table.params.status = ''
tableStore.table.params.supvType = ''

provide('tableStore', tableStore)
// 新增计划
const add = (id: string) => {
    planTestRef.value.open('计划测试填报', id, true)
}
// 禁止点击
const checkboxConfig = reactive({
    checkMethod: ({ row }) => {
        return adminInfo.roleCode.includes('delete_info')
            ? true
            : row.createBy == adminInfo.$state.id && row.status == 0
    }
})
const deleteEven = () => {
    if (tableStore.table.selection.length == 0) {
        ElMessage({
            type: 'warning',
            message: '请选择要删除的数据'
        })
    } else {
        ElMessageBox.confirm('此操作将永久删除, 是否继续?', '提示', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
        }).then(() => {
            deleteSurveyPlanTest(tableStore.table.selection.map(item => item.id)).then(res => {
                ElMessage({
                    type: 'success',
                    message: '删除成功!'
                })
                tableStore.index()
            })
        })
    }
}
const exportFn = () => {
    let form = JSON.parse(JSON.stringify(tableStore.table.params))
    form.pageNum = 1
    form.pageSize = tableStore.table.total
    queryPlan(form).then(res => {
        tableRef.value.getRef().exportData({
            filename: '计划', // 文件名字
            sheetName: 'Sheet1',
            type: 'xlsx', //导出文件类型 xlsx 和 csv
            useStyle: true,
            data: res.data.records, // 数据源 // 过滤那个字段导出
            columnFilterMethod: function (column: any) {
                return !(column.$columnIndex === 0)
            }
        })
    })
}

/**取消流程操作*/
const cancelLeave = async (row: any) => {
    // 二次确认
    const { value } = await ElMessageBox.prompt('请输入取消原因', '取消流程', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        inputType: 'textarea',
        inputPattern: /^[\s\S]*.*\S[\s\S]*$/, // 判断非空，且非空格
        inputErrorMessage: '取消原因不能为空'
    })
    // 发起取消
    let data = {
        id: row.id,
        processInstanceId: row.processInstanceId,
        reason: value
    }
    await cancelTest(data)
    ElMessage.success('取消成功')
    // 加载数据
    tableStore.index()
}

/** 处理审批按钮 */
const handleAudit = (instanceId: any, historyInstanceId: any) => {
    push({
        name: 'BpmProcessInstanceDetail',
        state: {
            id: instanceId,
            historyInstanceId
        }
    })
}
// 取消

onMounted(() => {
    tableStore.index()
    getUserByRoleType(3).then(res => {
        auditList.value = res.data
    })
})

const props = defineProps(['id', 'businessKey'])
watch(
    () => props.id,
    async (newValue, oldValue) => {
        if (newValue === 'null') return // 直接返回，避免后续逻辑执行
        const fullId = newValue.split('@')[0]
        let nowTime = Date.now()
        const routeTime = Number(newValue.split('@')[1])
        if (isNaN(routeTime) || nowTime - routeTime > import.meta.env.VITE_ROUTE_TIME_OUT) return // 路由时间超过500ms，则不执行
        nextTick(() => {
            if (props.businessKey == '3') {
                planTestRef.value.open('编辑', fullId, false)
            } else {
                planTestRef.value.open('重新发起计划测试', fullId, false)
            }
        })
    },
    { immediate: true }
)
</script>

<style scoped lang="scss"></style>
